/*
 * EPWINGVXe\tgdqTϊ[eBeB enssed
 *	Written by Junn Ohta (ohta@sdg.mdd.ricoh.co.jp), Public Domain.
 *
 * Ver.0.1 (2004/07/10)
 *	E
 *	Eɂ͖Ή
 *
 * Ver.0.2 (2004/11/20)
 *	EEPWING V6œmF
 *	EX[p[2004ɑΉ
 *	  (LܔłHONMONSEPWING V6kĂ)
 *	EX[p[98V̌АVpaTɑΉ
 *	  (TCY0̏Ѝ\vfƃG[ɂȂĂ)
 *	EEPWINGЖ̂64oCg𒴂ƕϊɎsoOC
 *	E2mkdir()ɑΉĂȂoOC
 *	E֐ύX log()  write_log()
 *	EmFςݏЂ̒ǉɍ킹icon.defXV
 */
char *prog	= "enssed";
char *version	= "0.2";
char *date	= "2004/11/20";

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <fcntl.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifdef __TURBOC__ /* Borland C++ */
#include <io.h>
#include <dir.h>
#else
#ifdef _WIN32 /* Visual C++ */
#include <io.h>
#include <direct.h>
#else /* UNIXen or MacOS X */
#include <unistd.h>
#endif
#endif

#if defined(__TURBOC__) || defined(_WIN32)
#define	makedir(p)	mkdir(p)
#else /* UNIXed or MacOS X */
#define	makedir(p)	mkdir(p, 0755)
#endif

#ifndef O_BINARY
#define	O_BINARY	0
#endif

#define	TRUE		1
#define	FALSE		0

typedef	unsigned char	byte;
typedef unsigned short	word;
typedef	unsigned long	dword;

#define	PATH_MAX	1024	/* pX̍ő咷 */

#define	DO_OPTIONAL	0x01	/* IvVivf𐶐 */
#define	DO_GRAPHICS	0x02	/* J[}Ńf[^𐶐 */
#define	DO_SOUND	0x04	/* f[^𐶐 */
#define	DO_ALL		(DO_OPTIONAL|DO_GRAPHICS|DO_SOUND)

char	*logfile = "enssed.log";

/*---------- dqubN/EPWING ----------*/

#define	BLOCK_SIZE	2048	/* EPWINGubNTCY */

#define	ID_HONMON	0x00	/* EPWING V2HONMONS/HONMONGւ̎QƂ܂ */
#define	ID_GRAPHMENU	0x10	/* EPWING V2HONMONGւ̎QƂ܂ */
#define	ID_GRAPHICS	0xd2	/* EPWING V2HONMONGɑΉID */
#define	ID_SOUND	0xd8	/* EPWING V2HONMONSɑΉID */
#define	ID_MULTI	0xff	/* ǗubNID */

#define	NOCOMP		0	/* k */
#define	V4COMP		1	/* EPWING V4k` */
#define	V6COMP		2	/* EPWING V6k` */

#define	NODE_INT	0	/* ԃm[h */
#define	NODE_LEAF8	1	/* tm[h(8rbgl) */
#define	NODE_LEAF16	2	/* tm[h(16rbgl) */
#define	NODE_LEAF32	3	/* tm[h(32rbgl) */
#define	NODE_EOF	4	/* tm[h(I[l) */

#define	NEXT		0	/* 㑱ubNǂ */

/*
 * dqubN/EPWINGJ^Owb_(16oCg)
 */
typedef struct catalog_header_t {
    byte	books[2];	/* o^А */
    byte	reserved1a[1];	/* \̈1 */
    byte	cdtype[1];	/* : dqubN=0, EPWING=1` */
    byte	select[2];	/* БIʂ̏Дԍ */
    byte	reserved1b[10];	/* \̈1 */
} CATHDR;

/*
 * dqubNJ^Of[^(40oCg)
 */
typedef struct eb_catalog_t {
    byte	booktype[2];	/* Ў? */
    byte	title[30];	/* Ж */
    byte	directory[8];	/* ЃfBNg */
} EBCAT;

/*
 * EPWINGJ^Of[^(164oCg)
 */
typedef struct epwing_catalog_t {
    byte	booktype[2];	/* Ў+EPWINGo[W */
    byte	title[80];	/* Ж */
    byte	directory[8];	/* ЃfBNg */
    byte	dirpos[4];	/* Ѓt@CfBNgʒu */
    byte	infono[2];	/* ЊǗL^ʒu */
    byte	reserved3[4];	/* \̈3 */
    byte	ga16full[8];	/* 16~16hbgOt@C */
    byte	ga24full[8];	/* 24~24hbgOt@C */
    byte	ga30full[8];	/* 30~30hbgOt@C */
    byte	ga48full[8];	/* 48~48hbgOt@C */
    byte	ga16half[8];	/* 8~16hbgOt@C */
    byte	ga24half[8];	/* 12~24hbgOt@C */
    byte	ga30half[8];	/* 15~30hbgOt@C */
    byte	ga48half[8];	/* 24~48hbgOt@C */
} EPWCAT;

/*
 * EPWINGgJ^Of[^(EPWING2ȍ~, 164oCg)
 */
typedef	struct epwing_catalog2_t {
    byte	functype[4];	/* @\ */
    byte	bookfile[8];	/* Ѓt@C */
    byte	reserved4[12];	/* \̈4 */
    byte	stdirpos[4];	/* AĐt@CfBNgʒu */
    byte	streamfile[8];	/* AĐt@C */
    byte	mmdirpos[4];	/* }`fBAt@CfBNgʒu */
    byte	mmtype[4];	/* }`fBAf[^ */
    byte	mmfile1[8];	/* }`fBAt@C1 */
    byte	comptype[4];	/* k */
    				/* 00000000: kĂȂ */
				/* 00000011: HONMON2=V4k */
				/* 00000012: HONMON2=V6k */
				/* 00120012: HONMON2=V6k, HONMONS=V6k */
    byte	mmfile2[8];	/* }`fBAt@C2 */
    byte	edition[2];	/*  */
    byte	reserved5[98];	/* \̈5 */
} EPWCAT2;

/*
 * HONMON/STARTЊǗwb_(16oCg)
 */
typedef struct info_header_t {
    byte	items[2];	/* Ѝ\vf */
    byte	reserved1[2];	/* \̈1 */
    byte	idxhndl[1];	/* CfbNX쐬̎戵@ */
    byte	reserved2[11];	/* \̈2 */
} INFOHDR;

/*
 * HONMON/STARTЊǗ(16oCg)
 */
typedef struct info_item_t {
    byte	itemid[1];	/* Ѝ\vfʎq */
    byte	reserved3[1];	/* \̈3 */
    byte	topblk[4];	/* 擪AhX */
    byte	blks[4];	/* ̈TCY */
    byte	idxvalid[1];	/* CfbNX쐬L */
    byte	idxinfo[3];	/* CfbNX쐬 */
    byte	reserved4[2];	/* \̈4 */
} INFOITEM;

/*
 * HONMON/STARTЊǗtb^(16oCg)
 */
typedef struct info_footer_t {
    byte	dspvalid[1];	/* LtO */
    byte	reserved5[3];	/* \̈5 */
    byte	dsplist[1];	/* ꗗ\\ */
    byte	dspstyle[1];	/* {\@ */
    byte	reserved6[10];	/* \̈6 */
} INFOFTR;

/*
 * EPWING V4/V6kwb_
 */
typedef struct compression_header_t {
    long	idxtbl;		/* kCfbNXJnʒu */
    long	idxlen;		/* kCfbNX̒ */
    long	freqtbl;	/* pxe[uJnʒu */
    long	freqlen;	/* pxe[u̒ */
    long	content;	/* {Jnʒu */
} COMPHDR;

/*
 * EPWING V4/V6kLpnt}؃m[h
 */
typedef struct hufftree_node_t HUFFNODE;
struct hufftree_node_t {
    HUFFNODE	*parent;	/* em[hCfbNX */
    HUFFNODE	*left;		/* qm[hCfbNX */
    HUFFNODE	*right;		/* Eqm[hCfbNX */
    int		type;		/* m[h̎ */
    int		freq;		/* pxl */
    byte	ch[4];		/* tm[h̒l(8/16/32rbg) */
};

/*
 * J^O
 */
typedef struct catalog_t {
    char	*catdir;	/* ݃fBNg */
    byte	*data;		/* J^Of[^ */
} CATALOG;

/*
 * Џ
 */
typedef struct book_t {
    char	*filename;	/* t@C */
    int		fd;		/* t@CLqq */
    int		comptype;	/* k` */
    COMPHDR	*comphdr;	/* kwb_ */
    HUFFNODE	*huffroot;	/* nt}؂̃[gm[h */
} BOOK;

/*---------- VXe\tgdqT ----------*/

#define	CHUNK_SIZE	32768	/* SSEDk`NTCY(16ubN) */
#define	LOOKUP_LEN	4080	/* LZ77XChQƕ */
#define	CODING_LEN	15	/* LZ77XCh */

#define	C_REQ		0	/* K{f[^(ɐ) */
#define	C_OPT		1	/* IvVif[^(-oŐ) */
#define	C_GRA		2	/* J[}Ńf[^(-gŐ) */
#define	C_SND		3	/* f[^(-sŐ) */
#define	C_XXX		9	/* VXe\tgdqTŎgpȂ */

/*
 * Ѝ\vft@C
 */
typedef struct file_info_t {
    byte	id;		/* Ѝ\vfʎq */
    byte	comp;		/* kKv? */
    byte	opt;		/* IvV */
    char	*name;		/* VXe\tgdqTt@C */
    byte	used;		/* Ɨp */
} FILEINFO;

FILEINFO fileinfo[] = {
    { 0x00, 1, C_REQ, "HONMON.DIC" },	/* 00: { */
    { 0x01, 1, C_REQ, "MENU.DIC" },	/* 01: j[ */
    { 0x02, 1, C_XXX, "COPYR.DIC" },	/* 02: 쌠\ */
    { 0x03, 1, C_OPT, "KWTITLE.DIC" },	/* 03: o */
    { 0x04, 1, C_REQ, "FKTITLE.DIC" },	/* 04: OvȌo */
    { 0x05, 1, C_REQ, "FHTITLE.DIC" },	/* 05: Ov\Lo */
    { 0x06, 1, C_REQ, "BKTITLE.DIC" },	/* 06: vȌo */
    { 0x07, 1, C_REQ, "BHTITLE.DIC" },	/* 07: v\Lo */
    { 0x08, 1, C_REQ, "FATITLE.DIC" },	/* 08: Ovpo */
    { 0x09, 1, C_REQ, "BATITLE.DIC" },	/* 08: vpo */
    { 0x0a, 1, C_OPT, "CRTITLE.DIC" },	/* 0A: NXo */
    { 0x0b, 1, C_XXX, "KOTITLE.DIC" },	/* 0B: ڔԍo */
    { 0x0d, 1, C_XXX, "JOTITLE.DIC" },	/* 0D: ڕʏo */
    { 0x0e, 1, C_XXX, "AUTODEMO.DIC" },	/* 0E: I[gf(EBXA) */
    { 0x0f, 1, C_XXX, "SCRTITLE.DIC" },	/* 0F: }Ōo */
    { 0x10, 1, C_XXX, "SCRMENU.DIC" },	/* 10: j[(摜) */
    { 0x11, 1, C_XXX, "COLMENU.DIC" },	/* 11: j[(J[摜) */
    { 0x12, 1, C_XXX, "KINSOKU.DIC" },	/* 12: ֑(EPWING5) */
    { 0x13, 1, C_XXX, "TEXT13.DIC" },	/* 13: ̑̃eLXgf[^ */
    { 0x14, 1, C_XXX, "TEXT14.DIC" },	/* 14: ̑̃eLXgf[^ */
    { 0x15, 1, C_XXX, "TEXT15.DIC" },	/* 15: ̑̃eLXgf[^ */
    { 0x16, 1, C_XXX, "MULTITLE.DIC" },	/* 16: o */
    { 0x20, 1, C_XXX, "MENU20.DIC" },	/* 20: j[ */
    { 0x21, 1, C_XXX, "COPYR21.DIC" },	/* 21: 쌠\ */
    { 0x22, 1, C_XXX, "MENU22.DIC" },	/* 22: j[? */
    { 0x23, 1, C_XXX, "COPYR23.DIC" },	/* 23: 쌠\(1s\p) */
    { 0x24, 1, C_XXX, "SNDTITLE.DIC" },	/* 24: o */
    { 0x30, 1, C_REQ, "KAINDEX.DIC" },	/* 30: ȃCfbNX */
    { 0x40, 1, C_REQ, "ENINDEX.DIC" },	/* 40: pCfbNX */
    { 0x50, 1, C_REQ, "KJINDEX.DIC" },	/* 50: CfbNX */
    { 0x60, 1, C_REQ, "HYINDEX.DIC" },	/* 60: \L`CfbNX */
    { 0x61, 1, C_XXX, "EWINDEX.DIC" },	/* 61: pPCfbNX(S-EBXA) */
    { 0x70, 1, C_REQ, "BKINDEX.DIC" },	/* 70: vȃCfbNX */
    { 0x71, 1, C_REQ, "BHINDEX.DIC" },	/* 71: v\LCfbNX */
    { 0x72, 1, C_REQ, "BAINDEX.DIC" },	/* 72: vpCfbNX */
    { 0x73, 1, C_XXX, "BOINDEX.DIC" },	/* 73: v̑CfbNX */
    { 0x80, 1, C_OPT, "KWINDEX.DIC" },	/* 80: CfbNX */
    { 0x81, 1, C_OPT, "CRINDEX.DIC" },	/* 81: NXCfbNX */
    { 0x90, 1, C_REQ, "FKINDEX.DIC" },	/* 90: OvȃCfbNX */
    { 0x91, 1, C_REQ, "FHINDEX.DIC" },	/* 91: Ov\LCfbNX */
    { 0x92, 1, C_REQ, "FAINDEX.DIC" },	/* 92: OvpCfbNX */
    { 0x93, 1, C_XXX, "FOINDEX.DIC" },	/* 93: Ov̑CfbNX */
    { 0xa0, 1, C_XXX, "KOINDEX.DIC" },	/* A0: ڔԍCfbNX */
    { 0xa1, 1, C_XXX, "JOINDEX.DIC" },	/* A1: ڕʏCfbNX */
    { 0xb0, 1, C_XXX, "PGINDEX.DIC" },	/* B0: y[WCfbNX */
    { 0xb1, 1, C_XXX, "PKINDEX.DIC" },	/* B1: y[WCfbNX */
    { 0xd0, 1, C_REQ, "MONOSCR.DIC" },	/* D0: mN} */
    { 0xd1, 1, C_XXX, "XMONOSCR.DIC" },	/* D1: gmN} */
    { 0xd2, 1, C_GRA, "COLSCR.DIC" },	/* D2: J[} */
    { 0xd8, 1, C_SND, "PCMDATA.DIC" },	/* D8: PCM */
    { 0xe0, 1, C_XXX, "COLSMPL.DIC" },	/* E0: F{ */
    { 0xee, 1, C_XXX, "COLDEMO.DIC" },	/* EE: I[gf(J[) */
    { 0xef, 1, C_XXX, "COLTITLE.DIC" },	/* EF: }Ōo(J[) */
    { 0xf0, 0, C_XXX, "AUTH.DIC" },	/* F0: Ï */
    { 0xf1, 0, C_REQ, "GA16FULL" },	/* F1: O(16~16)[dqubN] */
    { 0xf2, 0, C_REQ, "GA16HALF" },	/* F2: O(8~16)[dqubN] */
    { 0xfb, 0, C_XXX, "GATABLE.DIC" },	/* FB: O֕\? (S-EBXA) */
    { 0xff, 1, C_OPT, "MULTI?.DIC" }	/* FF: CfbNX */
};

#define	NINFO	(sizeof(fileinfo) / sizeof(fileinfo[0]))

/*
 * SSEDINFOt@Cwb_(128oCg)
 */
typedef struct ssedinfo_header_t {
    byte	cookie[8];	/* ʕ"SSEDINFO" */
    byte	unknown1[4];	/* 00 02 00 00`02 */
    byte	titlelen[1];	/* ^Cg */
    byte	title[64];	/* ^Cg */
    byte	items[1];	/* Ѝ\vf */
    byte	booktype[2];	/* Ў+EPWINGo[W? */
    byte	i32pos[4];	/* 32~32ACRJnʒu */
    byte	i32len[4];	/* 32~32ACR̈撷 */
    byte	i16pos[4];	/* 15~16ACRJnʒu */
    byte	i16len[4];	/* 15~16ACR̈撷 */
    byte	dicid[4];	/* ID(CXg[WXgɓ]?) */
    byte	unknown2[28];	/* ׂ 00 */
} SIHDR;

/*
 * SSEDINFOЍ\vf(48oCg)
 */
typedef struct ssedinfo_item_t {
    byte	unknown1[3];	/* 00 00 00? */
    byte	id[1];		/* Ѝ\vfID */
    byte	topblk[4];	/* 擪ubNԍ */
    byte	endblk[4];	/* ŏIubNԍ */
    byte	idxvalid[1];	/* CfbNX쐬L */
    byte	idxinfo[3];	/* CfbNX쐬 */
    byte	fnamelen[1];	/* t@C */
    byte	fname[31];	/* t@C */
} SIITEM;

/*
 * SSEDDATAt@Cwb_(64oCg)
 */
typedef struct sseddata_header_t {
    byte	cookie[8];	/* ʕ"SSEDDATA" */
    byte	unknown1[7];	/* 00 02 00 02 00 00 00 */
    byte	id[1];		/* Ѝ\vfID */
    byte	unknown2[6];	/* 00 10 10 00 00 10 */
    byte	chunks[2];	/* `N */
    byte	topblk[4];	/* 擪ubNԍ */
    byte	endblk[4];	/* ŏIubNԍ */
    byte	idxvalid[1];	/* CfbNX쐬L */
    byte	idxinfo[3];	/* CfbNX쐬 */
    byte	unknown3[28];	/* ׂ 00 */
} SDHDR;

/*
 * SSEDDATA`Ne[u(4oCg~chunks)
 */
typedef struct sseddata_chunk_table_t {
    byte	offset[4];	/* `NJnItZbg */
} CHUNKTBL;

/*
 * SSEDDATA`Nwb_(5oCg)
 */
typedef struct sseddata_chunk_header_t {
    byte	ndata[4];	/* LZ773gf[^ */
    byte	fillch[1];	/* XChl */
} CHUNKHDR;

/*
 * ACR`t@C
 */
#define	ICON_DEF_FILE	"icon.def"

/*
 * ftHg15s~16ACR({^\)
 */
char *def_icon16[15] = {
    "\x44\x44\x44\x44\x44\x44\x44\x44",
    "\x44\x44\x44\x44\x44\x44\x44\x44",
    "\x44\xFF\xFF\xF4\x4F\xFF\xFF\x44",
    "\x44\xFF\xFF\xF4\x4F\xFF\xF4\x44",
    "\x44\xF4\x44\x44\x4F\x44\x4F\x44",
    "\x44\xF4\x44\x44\x4F\x44\x4F\x44",
    "\x44\xFF\xFF\x44\x4F\xFF\xFF\x44",
    "\x44\xFF\xFF\x44\x4F\xFF\xF4\x44",
    "\x44\xF4\x44\x44\x4F\x44\x44\x44",
    "\x44\xF4\x44\x44\x4F\x44\x44\x44",
    "\x44\xF4\x44\x44\x4F\x44\x44\x44",
    "\x44\xFF\xFF\xF4\x4F\x44\x44\x44",
    "\x44\xFF\xFF\xF4\x4F\x44\x44\x44",
    "\x44\x44\x44\x44\x44\x44\x44\x44",
    "\x44\x44\x44\x44\x44\x44\x44\x44"
};

/*
 * ftHg32s~32ACR(ACR\)
 */
char *def_icon32[32] = {
    "\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77",
    "\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77",
    "\x77\x77\x70\x00\x00\x00\x00\x00\x00\x00\x00\x07\x77\x77\x77\x77",
    "\x77\x77\x08\x88\x88\x88\x88\x88\x88\x88\x80\x87\x77\x77\x77\x77",
    "\x77\x70\xBF\xBF\xBF\xBF\xBF\xBF\xBF\xBF\xB0\x08\x77\x77\x77\x77",
    "\x77\x70\x0B\xFB\xFB\xFB\xFB\xFB\xFB\xFB\xF0\x88\x87\x77\x77\x77",
    "\x77\x70\x70\x00\x00\x00\x00\x00\x00\x00\x00\x00\x88\x77\x77\x77",
    "\x77\x70\x77\x44\x44\x44\x44\x44\x44\x44\x44\x08\x88\x77\x77\x77",
    "\x77\x70\x77\x44\x44\x44\x44\x44\x44\x44\x44\x00\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xFF\xFF\xF4\x4F\xFF\xF4\x44\x08\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xF4\x44\x44\x4F\x44\x4F\x44\x00\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xFF\xFF\x44\x4F\xFF\xF4\x44\x08\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xF4\x44\x44\x4F\x44\x44\x44\x00\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xFF\xFF\xF4\x44\x44\x44\x44\x08\x88\x77\x77\x77",
    "\x77\x70\x77\x44\x44\x44\x44\x44\x44\x44\x44\x00\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xF4\xF4\xF4\x44\xFF\xF4\x44\x08\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xF4\xF4\xF4\x44\x4F\x44\x44\x00\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xF4\xF4\xF4\x44\x4F\x44\x44\x08\x88\x77\x77\x77",
    "\x77\x70\x77\x44\x4F\x4F\x44\x44\x4F\x44\x44\x00\x88\x77\x77\x77",
    "\x77\x70\x77\x44\x4F\x4F\x44\x44\xFF\xF4\x44\x08\x88\x77\x77\x77",
    "\x77\x70\x77\x44\x44\x44\x44\x44\x44\x44\x44\x00\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xF4\x44\xF4\x44\xFF\xF4\x44\x08\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xFF\x44\xF4\x4F\x44\x44\x44\x00\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xF4\xF4\xF4\x4F\x4F\xFF\x44\x08\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xF4\x4F\xF4\x4F\x44\x4F\x44\x00\x88\x77\x77\x77",
    "\x77\x70\x77\x44\xF4\x44\xF4\x44\xFF\xFF\x44\x08\x88\x77\x77\x77",
    "\x77\x70\x77\x44\x44\x44\x44\x44\x44\x44\x44\x00\x88\x77\x77\x77",
    "\x77\x77\x07\x44\x44\x44\x44\x44\x44\x44\x44\x08\x88\x77\x77\x77",
    "\x77\x77\x80\x00\x00\x00\x00\x00\x00\x00\x00\x00\x88\x77\x77\x77",
    "\x77\x77\x88\x08\x08\x08\x08\x08\x08\x08\x08\x08\x88\x77\x77\x77",
    "\x77\x77\x78\x88\x88\x88\x88\x88\x88\x88\x88\x88\x87\x77\x77\x77",
    "\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77\x77"
};

/*---------- LZ77pnbV֘A ----------*/

#define	HASH_SIZE	20443		/* CHUNK_SIZE~5ɋ߂f */
#define	H_EMPTY		((word)-1)	/* 󂫃Xbg */
#define	H_DELETED	((word)-2)	/* 폜ς݃Xbg */
#define	SYNONYM_MAX	30		/* Vmjő吔(ሳk) */

typedef struct hash_table_t {
    word	key;
    word	pos;
} HASHTBL;

/*
 * IvV
 */
int	nohash = FALSE;			/* LZ77kɃnbVgȂ */
int	doraw = FALSE;			/* t@C𖳈kō(debugp) */

/*
 * nbV֘Af[^
 */
HASHTBL	htbl[HASH_SIZE];		/* 3oCgnbV\ */
word	href[LOOKUP_LEN+CHUNK_SIZE];	/* nbVvfQƕ\ */
word	b2tbl[65536];			/* 2oCgŏIoʒu\ */
word	b1tbl[256];			/* 1oCgŏIoʒu\ */

/*
 * ֐vg^Cv
 */
void	usage(void);
void	start_log(void);
void	stop_log(void);
void	write_log(char *, ...);
void	log_options(int);
void	printtime(time_t, time_t);
dword	load_be(byte *, int);
void	store_be(byte *, int, dword);
dword	load_bcd4(byte *);
void	store_bcd4(byte *, dword);
void	trim_copy(char *, char *, int);
void	sjis_copy(char *, char *, int);
void	uppercase(char *);
void	make_path(char *, char *, char *, char *, char *);
CATALOG	*open_catalog(char *);
int	close_catalog(CATALOG *);
int	process_books(CATALOG *, char *, char *, int);
BOOK	*open_book(char *, int);
int	close_book(BOOK *);
HUFFNODE *make_hufftree(BOOK *);
byte	*read_block(byte *, BOOK *, dword);
dword	multi_blocks(BOOK *, dword *);
int	process_items(byte *, BOOK *, int, char *, char *, char *, BOOK *, BOOK *);
void	relocate_block(byte *, int, dword, dword, int *, int *);
int	generate_idxfile(byte *, BOOK *, byte *, int, char *, char *, char *, char *, dword);
int	generate_dicprof(char *, char *, char *, char *, dword);
int	generate_exinfo(char *, char *);
int	generate_regfile(char *, char *, dword);
int	copy_gaiji(char *, char *, char *);
dword	make_dicid(char *);
int	set_icon_data(char *, byte *, byte *);
int	find_key(FILE *, char *);
int	read_icon(FILE *, byte *, int, int);
int	find_fillch(byte *, int);
int	lz77_encode_dumb(byte *, byte *, int);
byte	*longest_match(byte *, int, byte *, int, int *);
int	lz77_encode_hash(byte *, byte *, int);
int	hash(byte *);
void	hash_init(byte *);
void	hash_insert(byte *, byte *, int);
void	hash_update(byte *, byte *, byte *, int);
int	find_match(byte *, byte *, int, int *);
int	matchlen(byte *, byte *, int);

int
main(int argc, char **argv)
{
    int opt;
    time_t t1, t2;
    char *directory, *newdir;
    CATALOG *catalog;

    argc--, argv++;
    opt = 0;
    nohash = FALSE;
    doraw = FALSE;
    while (argc > 0 && **argv == '-') {
	switch (argv[0][1]) {
	case 'o':
	case 'O':
	    opt |= DO_OPTIONAL;
	    break;
	case 'g':
	case 'G':
	    opt |= DO_GRAPHICS;
	    break;
	case 's':
	case 'S':
	    opt |= DO_SOUND;
	    break;
	case 'a':
	case 'A':
	    opt |= DO_ALL;
	    break;
	case 'n':
	case 'N':
	    nohash = TRUE;
	    break;
	case 'r':
	case 'R':
	    doraw = TRUE;
	    break;
	default:
	    usage();
	}
	argc--, argv++;
    }
    if (argc == 0 || argc > 3)
	usage();
    start_log();
    log_options(opt);
    time(&t1);
    catalog = open_catalog(argv[0]);
    if (catalog == NULL) {
	write_log("Can't open \"%s\"\n", argv[0]);
	stop_log();
	exit(1);
    }
    directory = NULL;
    newdir = NULL;
    if (argc >= 2) {
	directory = strdup(argv[1]);
	uppercase(directory);
    }
    if (argc >= 3) {
	if (strlen(argv[2]) > 8) {
	    write_log("New directory name too long (max 8 characters)\n");
	    stop_log();
	    exit(1);
	}
	newdir = strdup(argv[2]);
	uppercase(newdir);
    }
    process_books(catalog, directory, newdir, opt);
    close_catalog(catalog);
    write_log("Done.\n");
    time(&t2);
    printtime(t2, t1);
    stop_log();
    exit(0);
}

/*
 * gp@\
 */
void
usage(void)
{
    printf("%s Ver.%s %s\n", prog, version, date);
    printf("Usage: enssed [-o] [-g] [-s] [-a] [-x] catalog [subdir [newdir]]\n");
    printf("Options:\n");
    printf("    -o: generate optional components\n");
    printf("    -g: generate graphics component\n");
    printf("    -s: generate sound component\n");
    printf("    -a: same as \"-o -g -s\"\n");
    printf("Parameters:\n");
    printf("    catalog: pathname of CATALOG/CATALOGS file\n");
    printf("    subdir: subdirectory name to be processed\n");
    printf("    newdir: assign new name to subdir\n");
    exit(1);
}

/*
 * JnԂOt@Cɏ
 */
void
start_log(void)
{
    time_t t;
    FILE *fp;

    if ((fp = fopen(logfile, "a")) == NULL)
	return;
    time(&t);
    fprintf(fp, "Start: %s", ctime(&t));
    fclose(fp);
}

/*
 * IԂOt@Cɏ
 */
void
stop_log(void)
{
    time_t t;
    FILE *fp;

    if ((fp = fopen(logfile, "a")) == NULL)
	return;
    time(&t);
    fprintf(fp, "Stop: %s\n", ctime(&t));
    fclose(fp);
}

/*
 * bZ[W\AOt@Cɂ
 */
void
write_log(char *fmt, ...)
{
    char buf[BUFSIZ];
    FILE *fp;
    va_list ap;

    va_start(ap, fmt);
    vsprintf(buf, fmt, ap);
    va_end(ap);
    fputs(buf, stdout);
    if ((fp = fopen(logfile, "a")) == NULL)
	return;
    fputs(buf, fp);
    fclose(fp);
}

/*
 * wIvVOɏ
 */
void
log_options(int opt)
{
    write_log("Options:");
    if (opt & DO_OPTIONAL)
	write_log(" DO_OPTIONAL");
    if (opt & DO_GRAPHICS)
	write_log(" DO_GRAPHICS");
    if (opt & DO_SOUND)
	write_log(" DO_SOUND");
    if (nohash)
	write_log(" NO_HASH");
    if (doraw)
	write_log(" DO_RAW");
    write_log("\n");
}

/*
 * oߎԂ\
 */
void
printtime(time_t tend, time_t tstart)
{
    time_t t;

    t = tend - tstart;
    write_log("Time elapsed: %d:%02d\n", (int)(t / 60), (int)(t % 60));
}

/*
 * lbig endianƉ߂ēǂݏo
 */
dword
load_be(byte *buf, int len)
{
    dword val;

    val = 0L;
    while (len-- > 0)
	val = (val << 8) + (dword)*buf++;
    return val;
}

/*
 * lbig endianɕϊĊi[
 */
void
store_be(byte *buf, int len, dword val)
{
    buf += len;
    while (len-- > 0) {
	*--buf = (byte)(val & 0xff);
	val >>= 8;
    }
}

/*
 * lBCD4Ɖ߂ēǂݏo
 */
dword
load_bcd4(byte *buf)
{
    int len = 4;
    dword val;

    val = 0L;
    while (len-- > 0) {
	val = val * 100 + (dword)*buf / 16 * 10 + (dword)*buf % 16;
	buf++;
    }
    return val;
}

/*
 * lBCD4ɕϊĊi[
 */
void
store_bcd4(byte *buf, dword val)
{
    int len = 4;

    buf += len;
    while (len-- > 0) {
	*--buf = (byte)(val % 10);
	val /= 10;
	*buf |= (byte)(val % 10) << 4;
	val /= 10;
    }
}

/*
 * pfBŐ󔒂菜ăRs[
 */
void
trim_copy(char *dst, char *src, int len)
{
    char *send;

    send = src + len;
    while (send > src && (send[-1] == 0x20 || send[-1] == 0x00))
	send--;
    while (src < send)
	*dst++ = *src++;
    *dst = '\0';
}

/*
 * JISVtgJISɕϊȂRs[
 */
void
sjis_copy(char *dst, char *src, int len)
{
    int c1, c2;
    char *send;

    send = src + len;
    while (send > src && (send[-1] == 0x20 || send[-1] == 0x00))
	send--;
    while (src < send) {
	c1 = *src++;
	c2 = *src++;
	if ((c1 & 0x01) == 0) {
	    c2 += 0x7e;
	} else {
	    c2 += 0x1f;
	    if (c2 > 0x7e)
		c2++;
	}
	c1 = (c1 + 0xe1) >> 1;
	if (c1 > 0x9f)
	    c1 += 0x40;
	*dst++ = c1;
	*dst++ = c2;
    }
    *dst = '\0';
}

/*
 * 啶ɂ
 */
void
uppercase(char *str)
{
    if (str == NULL)
	return;
    while (*str) {
	if (*str >= 'a' && *str <= 'z')
	    *str = *str - 'a' + 'A';
	str++;
    }
}

/*
 * pXvfpX
 */
void
make_path(char *path, char *p0, char *p1, char *p2, char *p3)
{
    strcpy(path, p0);
    strcat(path, p1);
    if (p2 != NULL) {
	strcat(path, "/");
	strcat(path, p2);
    }
    if (p3 != NULL) {
	strcat(path, "/");
	strcat(path, p3);
    }
}

/*
 * J^OI[v
 */
CATALOG *
open_catalog(char *catalog_file)
{
    int fd;
    char *p;
    CATALOG *catalog;
    struct stat st;

    if (stat(catalog_file, &st) < 0)
	return NULL;
    if ((catalog = (CATALOG *)malloc(sizeof(CATALOG))) == NULL)
	return NULL;
    catalog->catdir = NULL;
    catalog->data = NULL;
    if ((catalog->catdir = strdup(catalog_file)) == NULL) {
	close_catalog(catalog);
	return NULL;
    }
    p = catalog->catdir + strlen(catalog->catdir);
    while (p > catalog->catdir && p[-1] != '/' && p[-1] != '\\' && p[-1] != ':')
	p--;
    *p = '\0';
    if ((catalog->data = (byte *)malloc(st.st_size)) == NULL) {
	close_catalog(catalog);
	return NULL;
    }
    if ((fd = open(catalog_file, O_RDONLY|O_BINARY)) < 0) {
	close_catalog(catalog);
	return NULL;
    }
    if (read(fd, catalog->data, (int)st.st_size) != st.st_size) {
	close_catalog(catalog);
	close(fd);
	return NULL;
    }
    close(fd);
    write_log("Working on %s\n", catalog_file);
    return catalog;
}

/*
 * J^ON[Y
 */
int
close_catalog(CATALOG *catalog)
{
    if (catalog) {
	if (catalog->catdir)
	    free((char *)catalog->catdir);
	if (catalog->data)
	    free((char *)catalog->data);
	free((char *)catalog);
    }
    return 0;
}

/*
 * J^O̊eЂ
 */
int
process_books(CATALOG *catalog, char *todo, char *newdir, int opt)
{
    int i, cdtype, books, done, comptype, mm2comp;
    char *catdir, *destdir, bookpath[PATH_MAX];
    char title[65], directory[9], honmon[9], dirpath[32];
    byte *booktype, infoblk[BLOCK_SIZE];
    dword infono, dicid;
    BOOK *book;
    CATHDR *cathdr;

    done = 0;
    catdir = catalog->catdir;
    cathdr = (CATHDR *)(catalog->data);
    books = (int)load_be(cathdr->books, 2);
    cdtype = cathdr->cdtype[0];
#ifdef DEBUG
    write_log("catdir=%s, books=%d, cdtype=0x%02x\n", catdir, books, cdtype);
#endif
    if (cdtype == 0x00)	{
	/*
	 * dqubN
	 */
	EBCAT *ebcat;

	ebcat = (EBCAT *)&cathdr[1];
	for (i = 0; i < books; i++, ebcat++) {
	    sjis_copy(title, ebcat->title, 30);
	    trim_copy(directory, ebcat->directory, 8);
	    uppercase(directory);
	    if (todo && strcmp(directory, todo)) {
		/*
		 * fBNgw肪ꍇ
		 * ̃fBNgȊOȂ
		 */
		continue;
	    }
	    make_path(bookpath, catdir, directory, "START", NULL);
	    infono = 1L;
	    booktype = ebcat->booktype;
#ifdef DEBUG
	    write_log("title=%s, dir=%s, honmon=%s\n",
		title, directory, bookpath);
#endif
	    if (newdir) {
		write_log("Processing %s -> %s ...\n", directory, newdir);
		destdir = newdir;
	    } else {
		write_log("Processing %s ...\n", directory);
		destdir = directory;
	    }
	    dicid = make_dicid(destdir);
	    sprintf(dirpath, "Dic/%s", destdir);
	    makedir("Dic");
	    makedir(dirpath);
	    if ((book = open_book(bookpath, NOCOMP)) == NULL) {
		write_log("Can't open \"%s\"\n", bookpath);
		continue;
	    }
	    if (read_block(infoblk, book, infono) == NULL) {
		write_log("Can't read information block\n");
		close_book(book);
		continue;
	    }
	    process_items(infoblk, book, opt, destdir, "", "", NULL, NULL);
	    generate_idxfile(infoblk, book, booktype, opt, destdir, title, "", "", dicid);
	    close_book(book);
	    generate_dicprof(destdir, title, "", "", dicid);
	    generate_exinfo(destdir, title);
	    generate_regfile(destdir, title, dicid);
	    done++;
	}
    } else {
	/*
	 * EPWING
	 */
	char gfile[9], sfile[9], ga16full[9], ga16half[9];
	char gfpath[PATH_MAX], ghpath[PATH_MAX];
	BOOK *graphics, *sound;
	EPWCAT *epwcat;
	EPWCAT2 *epwcat2;

	epwcat = (EPWCAT *)&cathdr[1];
	epwcat2 = (EPWCAT2 *)&epwcat[books];
	for (i = 0; i < books; i++, epwcat++, epwcat2++) {
#ifdef DEBUG
	    write_log("booktype=%02x%02x, comptype=%02x%02x%02x%02x\n",
		epwcat->booktype[0], epwcat->booktype[1],
		epwcat2->comptype[0], epwcat2->comptype[1],
		epwcat2->comptype[2], epwcat2->comptype[3]);
#endif
	    sjis_copy(title, epwcat->title, 64);
		/*
		 * EPWINGЂ̃^Cg͍ő80oCgA
		 * VXe\tg̃^Cg̈64oCgȂB
		 * ł͐擪64oCgRs[B
		 * (ؖ{̎wEɂoOC)
		 */
	    trim_copy(directory, epwcat->directory, 8);
	    uppercase(directory);
	    if (todo && strcmp(directory, todo)) {
		/*
		 * fBNgw肪ꍇ
		 * ̃fBNgȊOȂ
		 */
		continue;
	    }
	    if (epwcat->booktype[0] == 0xf0) {
		/*
		 * Xg[(F0)͏Ȃ
		 */
		write_log("Skipping %s (stream book)\n", directory);
		continue;
	    }
	    infono = load_be(epwcat->infono, 2);
	    if (epwcat->booktype[1] >= 0x02)	/* EPWING V2` */
		trim_copy(honmon, epwcat2->bookfile, 8);
	    else				/* EPWING V1 */
		strcpy(honmon, "HONMON");
	    make_path(bookpath, catdir, directory, "DATA", honmon);
	    if (epwcat->ga16full[0]) {
		trim_copy(ga16full, epwcat->ga16full, 8);
		make_path(gfpath, catdir, directory, "GAIJI", ga16full);
	    } else {
		*ga16full = '\0';
		*gfpath = '\0';
	    }
	    if (epwcat->ga16half[0]) {
		trim_copy(ga16half, epwcat->ga16half, 8);
		make_path(ghpath, catdir, directory, "GAIJI", ga16half);
	    } else {
		*ga16half = '\0';
		*ghpath = '\0';
	    }
	    booktype = epwcat->booktype;
	    comptype = NOCOMP;
	    mm2comp = NOCOMP;
	    if (epwcat->booktype[1] >= 0x02) {
		if (epwcat2->comptype[3] == 0x11)
		    comptype = V4COMP;
		else if (epwcat2->comptype[3] == 0x12)
		    comptype = V6COMP;
		if (epwcat2->comptype[1] == 0x11)
		    mm2comp = V4COMP;
		else if (epwcat2->comptype[1] == 0x12)
		    mm2comp = V6COMP;
	    }
#ifdef DEBUG
	    write_log("bt=%02x%02x, title=%s, dir=%s, info=%d",
		epwcat->booktype[0], epwcat->booktype[1],
		title, directory, infono);
	    if (epwcat->booktype[1] >= 0x02) { int i;
		write_log(", comp=0x");
		for (i = 0; i < 4; i++)
		    write_log("%02x", epwcat2->comptype[i]);
	    }
	    write_log("\n  h=%s", bookpath);
	    if (*gfpath) write_log(", gf=%s", gfpath);
	    if (*ghpath) write_log(", gh=%s", ghpath);
	    write_log("\n");
#endif
	    if (newdir) {
		write_log("Processing %s -> %s ...\n", directory, newdir);
		destdir = newdir;
	    } else {
		write_log("Processing %s ...\n", directory);
		destdir = directory;
	    }
	    dicid = make_dicid(destdir);
	    sprintf(dirpath, "Dic/%s", destdir);
	    makedir("Dic");
	    makedir(dirpath);
	    if ((book = open_book(bookpath, comptype)) == NULL) {
		write_log("Can't open \"%s\"\n", bookpath);
		continue;
	    }
	    if (read_block(infoblk, book, infono) == NULL) {
		write_log("Can't read information block\n");
		close_book(book);
		continue;
	    }
	    graphics = NULL;
	    sound = NULL;
	    if (epwcat->booktype[1] >= 0x02) {	/* EPWING V2` */
		trim_copy(gfile, epwcat2->mmfile1, 8);
		if (*gfile) {
		    make_path(bookpath, catdir, directory, "DATA", gfile);
		    if ((graphics = open_book(bookpath, NOCOMP)) == NULL) {
			write_log("Can't open \"%s\"\n", bookpath);
			continue;
		    }
		}
		trim_copy(sfile, epwcat2->mmfile2, 8);
		if (*sfile) {
		    make_path(bookpath, catdir, directory, "DATA", sfile);
		    if ((sound = open_book(bookpath, mm2comp)) == NULL) {
			write_log("Can't open \"%s\"\n", bookpath);
			continue;
		    }
		}
	    }
	    process_items(infoblk, book, opt, destdir, ga16full, ga16half, graphics, sound);
	    if (graphics)
		close_book(graphics);
	    if (sound)
		close_book(sound);
	    if (*gfpath && *ga16full)
		copy_gaiji(gfpath, destdir, ga16full);
	    if (*ghpath && *ga16half)
		copy_gaiji(ghpath, destdir, ga16half);
	    generate_idxfile(infoblk, book, booktype, opt, destdir, title, ga16full, ga16half, dicid);
	    close_book(book);
	    generate_dicprof(destdir, title, ga16full, ga16half, dicid);
	    generate_exinfo(destdir, title);
	    generate_regfile(destdir, title, dicid);
	    done++;
	}
    }
    if (done == 0)
	write_log("Nothing to do.\n");
    return 0;
}

/*
 * HONMON/STARTI[v
 */
BOOK *
open_book(char *bookpath, int comptype)
{
    byte *p, buf[20];
    BOOK *book;

    if ((book = (BOOK *)malloc(sizeof(BOOK))) == NULL)
	return NULL;
    book->filename = NULL;
    book->fd = -1;
    book->comptype = NOCOMP;
    book->comphdr = NULL;
    book->huffroot = NULL;
    p = bookpath + strlen(bookpath);
    while (p > (byte *)bookpath && p[-1] != '/' && p[-1] != '\\' && p[-1] != ':')
	p--;
    if ((book->filename = strdup(p)) == NULL) {
	close_book(book);
	return NULL;
    }
    if ((book->fd = open(bookpath, O_RDONLY|O_BINARY)) < 0) {
	close_book(book);
	return NULL;
    }
    if (comptype == V4COMP || comptype == V6COMP) {
	book->comptype = comptype;
	/*
	 * kwb_ǂ
	 */
	if ((book->comphdr = (COMPHDR *)malloc(sizeof(COMPHDR))) == NULL) {
	    close_book(book);
	    return NULL;
	}
	if (read(book->fd, buf, 20) != 20) {
	    close_book(book);
	    return NULL;
	}
	book->comphdr->idxtbl = (long)load_be(&buf[0], 4);
	book->comphdr->idxlen = (long)load_be(&buf[4], 4);
	book->comphdr->freqtbl = (long)load_be(&buf[8], 4);
	book->comphdr->freqlen = (long)load_be(&buf[12], 4);
	book->comphdr->content = (long)load_be(&buf[16], 4);
#ifdef DEBUG
	write_log("idxtbl=%ld, idxlen=%ld, freqtbl=%ld, freqlen=%ld\n",
	    book->comphdr->idxtbl,
	    book->comphdr->idxlen,
	    book->comphdr->freqtbl,
	    book->comphdr->freqlen);
#endif
	/*
	 * Lpnt}؂
	 */
	if ((book->huffroot = make_hufftree(book)) == NULL) {
	    close_book(book);
	    return NULL;
	}
    }
    return book;
}

/*
 * HONMON/STARTN[Y
 */
int
close_book(BOOK *book)
{
    if (book) {
	if (book->fd >= 0)
	    close(book->fd);
	if (book->comphdr != NULL)
	    free((char *)book->comphdr);
	if (book->huffroot != NULL)
	    free((char *)book->huffroot->parent);
	free((char *)book);
    }
    return 0;
}

/*
 * EPWING V4/V6kLpnt}؂
 */
HUFFNODE *
make_hufftree(BOOK *book)
{
    int i, j, n, top;
    int nent, ent32, ent16, ent8;
    byte buf[6];
    HUFFNODE *node, tmp;

    /*
     * pxe[uǂݍ
     */
    if (book->comptype == V6COMP) {
	ent8 = 256;
	ent16 = 1024;
	ent32 = ((int)book->comphdr->freqlen - (1024 * 4) - (256 * 2)) / 6;
    } else /* if (book->comptype == V4COMP) */ {
	ent8 = 256;
	ent16 = ((int)book->comphdr->freqlen - (256 * 2)) / 4;
	ent32 = 0;
    }
    nent = (ent32 + ent16 + ent8 + 1) * 2 - 1;
#ifdef DEBUG
    write_log("nent=%d, ent32=%d, ent16=%d, ent8=%d\n",
	nent, ent32, ent16, ent8);
#endif
    if ((node = (HUFFNODE *)malloc(sizeof(HUFFNODE) * nent)) == NULL)
	goto err;
    if (lseek(book->fd, book->comphdr->freqtbl, SEEK_SET) < 0)
	goto err;
    for (i = 0; i < nent; i++) {
	node[i].parent = NULL;
	node[i].left = NULL;
	node[i].right = NULL;
    }
    top = 0;
    for (i = 0; i < ent32; i++) {
	if (read(book->fd, (char *)buf, 6) != 6)
	    goto err;
	memcpy(node[top].ch, buf, 4);
	node[top].freq = (int)load_be(&buf[4], 2);
	node[top].type = NODE_LEAF32;
#ifdef DEBUG
	write_log("ch=%02x%02x%02x%02x, freq=%04x\n",
	    buf[0], buf[1], buf[2], buf[3], (int)(node[top].freq));
#endif
	top++;
    }
    for (i = 0; i < ent16; i++) {
	if (read(book->fd, (char *)buf, 4) != 4)
	    goto err;
	memcpy(node[top].ch, buf, 2);
	node[top].freq = (int)load_be(&buf[2], 2);
	node[top].type = NODE_LEAF16;
#ifdef DEBUG
	write_log("ch=%02x%02x, freq=%04x\n",
	    buf[0], buf[1], (int)(node[top].freq));
#endif
	top++;
    }
    for (i = 0; i < ent8; i++) {
	if (read(book->fd, (char *)buf, 2) != 2)
	    goto err;
	node[top].ch[0] = (byte)i;
	node[top].freq = (int)load_be(buf, 2);
	node[top].type = NODE_LEAF8;
#ifdef DEBUG
	write_log("ch=%02x, freq=%04x\n", node[top].ch[0], (int)(node[top].freq));
#endif
	top++;
    }
    node[top].freq = (int)1;
    node[top].type = NODE_EOF;
    top++;
    /*
     * m[hz\[g
     */
    for (i = 0; i < top - 1; i++) {
	n = i;
	for (j = i; j < top; j++) {
	    if (node[j].freq > node[n].freq)
		n = j;
	}
	tmp = node[i];
	node[i] = node[n];
	node[n] = tmp;
    }
#ifdef DEBUG
    for (i = 0; i < top; i++)
	write_log("i=%d, freq=%04x\n", i, node[i].freq);
#endif
    /*
     * nt}؂gݗĂ
     */
    while (top < nent) {
	int freq, left, right;
	freq = 0x7fffffff;
	for (i = 0; i < top; i++) {
	    if (node[i].parent != NULL)
		continue;
	    if (node[i].freq <= freq) {
		freq = node[i].freq;
		left = i;
	    }
	}
	freq = 0x7fffffff;
	for (i = 0; i < top; i++) {
	    if (i == left || node[i].parent != NULL)
		continue;
	    if (node[i].freq <= freq) {
		freq = node[i].freq;
		right = i;
	    }
	}
#ifdef DEBUG
	write_log("left=%d, right=%d, lfreq=%08x, rfreq=%08x\n",
	    left, right, node[left].freq, node[right].freq);
#endif
	node[left].parent = &node[top];
	node[right].parent = &node[top];
	node[top].type = NODE_INT;
	node[top].freq = node[left].freq + node[right].freq;
	node[top].left = &node[left];
	node[top].right = &node[right];
	top++;
    }
    node[nent-1].parent = node; /* free()p */
#ifdef DEBUG
    write_log("top=%d\n", top);
    for (i = 0; i < nent; i++) {
	if (node[i].parent == NULL)
	    write_log("node[%d].parent = NULL\n", i);
    }
#endif
    return &node[nent-1];
err:
    if (node != NULL)
	free((char *)node);
    return NULL;
}

/*
 * HONMON/START̎wubNǂݍ
 */
#define	GETBIT() \
    (curbit < 0 \
	? curbit = 6, (*++curbyte >> 7) & 1 \
	: (*curbyte >> curbit--) & 1)

byte *
read_block(byte *outbuf, BOOK *book, dword no)
{
    int i;
    int curbit;
    long off;
    byte *p, *pend, *cp, *curbyte, buf[BLOCK_SIZE];
    HUFFNODE *node;
    static int curno;

    if (book == NULL || book->fd == -1)
	return NULL;
    if (book->comptype == NOCOMP) {
	/*
	 * 񈳏k`̏ꍇ
	 */
	if (no != NEXT) {
	    curno = no;
	    if (lseek(book->fd, (long)BLOCK_SIZE * (no - 1), SEEK_SET) < 0)
		return NULL;
	}
	if (read(book->fd, outbuf, BLOCK_SIZE) != BLOCK_SIZE)
	    return NULL;
	curno++;
	return outbuf;
    }
    /*
     * EPWING V4/V6k̏ꍇ
     */
    if (no != NEXT)
	curno = no;
#ifdef DEBUG
    if (curno < 10)
	write_log("no=%d, curno=%d", no, curno);
#endif
    /*
     * kubNJnʒu𓾂
     */
    off = book->comphdr->idxtbl + ((curno - 1) / 16 * 36);
    if (lseek(book->fd, off, SEEK_SET) < 0 ||
	read(book->fd, buf, 36) != 36)
	return NULL;
#ifdef DEBUG
    if (curno < 10)
	write_log(", idx=%08lx", off);
#endif
    off = (long)load_be(buf, 4) + (long)load_be(&buf[(curno-1)%16*2+4], 2);
    if (lseek(book->fd, off, SEEK_SET) < 0)
	return NULL;
#ifdef DEBUG
    if (curno < 10)
	write_log(", con=%08lx\n", off);
#endif
    /*
     * EPWING V6kȂ爳kʂǂ
     */
    if (book->comptype == V6COMP) {
	if (read(book->fd, buf, 1) != 1)
	    return NULL;
	if (*buf != 0x00) {
	    /*
	     * 񈳏kubNǂŕԂ
	     */
	    if (read(book->fd, outbuf, BLOCK_SIZE) != BLOCK_SIZE)
		return NULL;
	    curno++;
	    return outbuf;
	}
    }
    /*
     * kubNǂݍ
     */
    if (read(book->fd, buf, BLOCK_SIZE) <= 0)
	return NULL;
    /*
     * nt}kL
     */
    curbyte = buf;
    curbit = 7;
    p = outbuf;
    pend = &outbuf[BLOCK_SIZE];
    while (p < pend) {
	node = book->huffroot;
	while (node->type == NODE_INT) {
	    if (GETBIT() == 1)
		node = node->left;
	    else
		node = node->right;
	}
	if (node->type == NODE_EOF)
	    break;
	cp = node->ch;
	*p++ = *cp++;		/* LEAF8, LEAF16, LEAF32 */
	if (p < pend && node->type != NODE_LEAF8)
	    *p++ = *cp++;	/* LEAF16, LEAF32 */
	if (p < pend && node->type == NODE_LEAF32) {
	    *p++ = *cp++;	/* LEAF32 */
	    if (p < pend)
		*p++ = *cp;	/* LEAF32 */
	}
    }
    if (p < pend)
	memset(p, '\0', pend - p);
    curno++;
    return outbuf;
}

/*
 * CfbNX̐擪ubNƃubN𓾂
 *
 * ǗubN:
 *   WORD	Gg
 *   BYTE14	\̈1
 *		(ȉGgԂ)
 *     BYTE	  Ѝ\vf
 *     BYTE	  \̈2
 *     BYTE30	  
 *		  (ȉvfԂ)
 *       BYTE	    Ѝ\vfʎq
 *       BYTE	    \̈3
 *       DWORD	    擪AhX(ubNԍ)
 *       DWORD	    ̈TCY(ubN)
 *       BYTE6	    \̈4
 */
dword
multi_blocks(BOOK *book, dword *blkno)
{
    int i, j, ents, items;
    dword tb, eb, blks, topblk, endblk;
    byte *p, buf[BLOCK_SIZE];

    topblk = endblk = *blkno;
    if (read_block(buf, book, topblk) == NULL)
	return (dword)0;
    p = buf;
    ents = (int)load_be(buf, 2);
    p += 16;
    for (i = 0; i < ents; i++) {
	items = (int)*p;
	p += 32;
	for (j = 0; j < items; j++, p += 16) {
	    blks = load_be(p + 6, 4);
	    if (blks == 0L) {
		/*
		 * X[p[98V̌АVpaTł
		 * Ɋ܂܂鍀ڕʏo(0D)
		 * 擪ubNԍ0AubN0ɂȂĂB
		 * ł͏Ѝ\vf݂Ȃ̂Ƃ
		 * PɖB
		 */
		continue;
	    }
	    tb = load_be(p + 2, 4);
	    eb = tb + blks - 1;
	    if (tb < topblk)
		topblk = tb;
	    if (eb > endblk)
		endblk = eb;
	}
    }
    *blkno = topblk;
    return endblk - topblk + 1;
}

/*
 * В̊e\vf
 */
int
process_items(byte *infoblk, BOOK *book, int opt, char *directory, char *ga16full, char *ga16half, BOOK *graphics, BOOK *sound)
{
    int i, n, m, fd, id, items, chunks, len, prefetch;
    int chunkno, nocomp, files, cblks, multino;
    int g_count, g_total, s_count, s_total;
    dword topblk, endblk, curblk, blks, where, offset;
    dword newblk, g_topblk, g_blks, g_reloc, s_topblk, s_blks, s_reloc;
    long off;
    char *msg, *dicfile, multifile[32], dicpath[32];
    byte *p, *src, fillch;
    BOOK *curbook;
    INFOHDR *infohdr;
    INFOITEM *infoitem;
    SDHDR sdhdr;
    CHUNKTBL *ctbl;
    CHUNKHDR chdr;
    static byte buf[LOOKUP_LEN + CHUNK_SIZE + BLOCK_SIZE];
    static byte dst[CHUNK_SIZE * 3];

    infohdr = (INFOHDR *)infoblk;
    items = (int)load_be(infohdr->items, 2);
    infoitem = (INFOITEM *)&infohdr[1];
    /*
     * t@Cƃ`N̍vvZĕ\
     * ܂EPWING V2HONMONG/HONMONSĔzu邽
     * Kvȏ߂
     */
    for (i = 0; i < NINFO; i++)
	fileinfo[i].used = 0;
    chunks = 0;
    files = 4;	/* <dir>.idx, dicprof.ini, exinfo.ini, <dir>.reg */
    newblk = (dword)0;
    for (i = 0; i < items; i++) {
	topblk = load_be(infoitem[i].topblk, 4);
	id = infoitem[i].itemid[0];
	if (id == ID_MULTI)
	    blks = multi_blocks(book, &topblk);
	else
	    blks = load_be(infoitem[i].blks, 4);
	if (id == ID_GRAPHICS && graphics != NULL) {
	    g_topblk = topblk;
	    g_blks = blks;
	} else if (id == ID_SOUND && sound != NULL) {
	    s_topblk = topblk;
	    s_blks = blks;
	} else {
	    if (topblk + blks > newblk)
		newblk = topblk + blks;
	}
	for (n = 0; n < NINFO; n++) {
	    if (fileinfo[n].id != infoitem[i].itemid[0])
		continue;
	    m = fileinfo[n].opt;
	    if (m == C_XXX ||
		m == C_OPT && !(opt & DO_OPTIONAL) ||
		m == C_GRA && !(opt & DO_GRAPHICS) ||
		m == C_SND && !(opt & DO_SOUND))
		continue;
	    fileinfo[n].used++;
	    cblks = CHUNK_SIZE / BLOCK_SIZE;
	    chunks += (blks + cblks - 1) / cblks;
	    files++;
	}
    }
    if (*ga16full)
	files++;
    if (*ga16half)
	files++;
    g_reloc = (dword)0;
    s_reloc = (dword)0;
    if (graphics != NULL) {
	g_reloc = newblk - g_topblk;
	g_topblk = newblk;
	newblk += g_blks;
    }
    if (sound != NULL) {
	s_reloc = newblk - s_topblk;
	s_topblk = newblk;
	newblk += s_blks;
    }
    write_log("  Total %d files, %d chunks to go.\n", files, chunks);
    /*
     * eЍ\vfkăt@Co
     */
    multino = 1;
    for (i = 0; i < items; i++, infoitem++) {
	for (n = 0; n < NINFO; n++) {
	    if (fileinfo[n].id != infoitem->itemid[0])
		continue;
	    m = fileinfo[n].opt;
	    if (m == C_XXX ||
		m == C_OPT && !(opt & DO_OPTIONAL) ||
		m == C_GRA && !(opt & DO_GRAPHICS) ||
		m == C_SND && !(opt & DO_SOUND))
		continue;
	    goto found;
	}
	continue;
    found:
	/*
	 * t@CVK쐬
	 */
	id = fileinfo[n].id;
	if (id == ID_MULTI) {
	    sprintf(multifile, "MULTI%d.DIC", multino++);
	    dicfile = multifile;
	} else {
	    dicfile = fileinfo[n].name;
	}
	sprintf(dicpath, "Dic/%s/%s", directory, dicfile);
	if ((fd = open(dicpath, O_CREAT|O_WRONLY|O_TRUNC|O_BINARY, 0666)) < 0) {
	    write_log("Can't create \"%s\"\n", dicpath);
	    return -1;
	}
	if (id == ID_GRAPHICS && graphics != NULL)
	    curbook = graphics;
	else if (id == ID_SOUND && sound != NULL)
	    curbook = sound;
	else
	    curbook = book;
	nocomp = (fileinfo[n].comp == FALSE);
	topblk = load_be(infoitem->topblk, 4);
	if (id == ID_MULTI)
	    blks = multi_blocks(book, &topblk);
	else
	    blks = load_be(infoitem->blks, 4);
	endblk = topblk + blks - 1;
	if (id == ID_GRAPHICS && graphics != NULL)
	    store_be(infoitem->topblk, 4, g_topblk);
	else if (id == ID_SOUND && sound != NULL)
	    store_be(infoitem->topblk, 4, s_topblk);
	cblks = CHUNK_SIZE / BLOCK_SIZE;
	chunks = (blks + cblks - 1) / cblks;
	g_total = 0;
	s_total = 0;
	if (doraw || nocomp) {
	    /*
	     * ksvȃt@C(O)͂̂܂܏
	     * (IvV-rw肳ꂽƂׂ͂Ă
	     * t@Cwb_tAk
	     * oBdebugp)
	     */
	    curblk = topblk;
	    prefetch = FALSE;
	    for (n = 0; n < chunks; n++) {
		printf("\r  Writing %s (%d/%d chunks)", dicfile, n+1, chunks);
		/*
		 * 1`Nǂݍ
		 */
		where = curblk;
		p = buf;
		len = 0;
		if (prefetch) {
		    /*
		     * buf̖ɐǂ݂ubNȂ
		     * buf̐擪ɃRs[
		     */
		    memcpy(p, p + CHUNK_SIZE, BLOCK_SIZE);
		    p += BLOCK_SIZE;
		    len += BLOCK_SIZE;
		    prefetch = FALSE;
		}
		while (curblk <= endblk && len < CHUNK_SIZE) {
		    if (read_block(p, curbook, where) == NULL) {
			msg = "\nread_block() failed. (1)";
			goto err1;
		    }
		    curblk++;
		    where = NEXT;
		    p += BLOCK_SIZE;
		    len += BLOCK_SIZE;
		}
		if (curblk <= endblk) {
		    /*
		     * `N̖1ubNǂ݂
		     */
		    if (read_block(p, curbook, where) == NULL) {
			msg = "\nread_block() failed. (2)";
			goto err1;
		    }
		    curblk++;
		    prefetch = TRUE;
		}
		/*
		 * HONMONS/HONMONGւ̎QƂȂĔzu
		 */
		if (id == ID_HONMON && (graphics != NULL || sound != NULL) ||
		    id == ID_GRAPHMENU && graphics != NULL) {
		    relocate_block(buf, len, g_reloc, s_reloc, &g_count, &s_count);
		    g_total += g_count;
		    s_total += s_count;
		}
		/*
		 * `No
		 */
		if (write(fd, buf, len) != len) {
		    msg = "\nwrite() failed. (3)";
		    goto err1;
		}
	    }
	    printf("\r");
	    write_log("  Writing %s (%d/%d chunks)\n", dicfile, chunks, chunks);
	    if (g_total > 0 && graphics != NULL) {
		write_log("    %s references relocated (%d occurrences)\n",
		    graphics->filename, g_total);
	    }
	    if (s_total > 0 && sound != NULL) {
		write_log("    %s references relocated (%d occurrences)\n",
		    sound->filename, s_total);
	    }
	    continue;
	}
	/*
	 * kKvȃt@Cɂăwb_
	 */
	memset(&sdhdr, '\0', sizeof(sdhdr));
	memcpy(sdhdr.cookie, "SSEDDATA", 8);
	memcpy(sdhdr.unknown1, "\x00\x02\x00\x02\x00\x00\x00", 7);
	memcpy(sdhdr.id, infoitem->itemid, 1);
	memcpy(sdhdr.unknown2, "\x00\x10\x10\x00\x00\x10", 6);
	store_be(sdhdr.chunks, 2, (dword)chunks);
	if (id == ID_GRAPHICS && graphics != NULL) {
	    store_be(sdhdr.topblk, 4, g_topblk);
	    store_be(sdhdr.endblk, 4, g_topblk + g_blks - 1);
	} else if (id == ID_SOUND && sound != NULL) {
	    store_be(sdhdr.topblk, 4, s_topblk);
	    store_be(sdhdr.endblk, 4, s_topblk + s_blks - 1);
	} else {
	    store_be(sdhdr.topblk, 4, topblk);
	    store_be(sdhdr.endblk, 4, endblk);
	}
	memcpy(sdhdr.idxvalid, infoitem->idxvalid, 1);
	memcpy(sdhdr.idxinfo, infoitem->idxinfo, 3);
	if (write(fd, &sdhdr, sizeof(sdhdr)) != sizeof(sdhdr)) {
	    msg = "write() failed. (4)";
	    goto err;
	}
	/*
	 * `NItZbg\蓖Ă
	 */
	ctbl = (CHUNKTBL *)malloc(sizeof(CHUNKTBL) * chunks);
	if (ctbl == NULL) {
	    msg = "malloc() failed. (5)";
	    goto err;
	}
	/*
	 * Ѝ\vfkă`Nɒǉ
	 */
	off = sizeof(sdhdr) + (sizeof(dword) * chunks);
	if (lseek(fd, off, SEEK_SET) < 0) {
	    msg = "lseek() failed. (6)";
	    goto err;
	}
	src = buf + LOOKUP_LEN;
	curblk = topblk;
	prefetch = FALSE;
	for (n = 0; n < chunks; n++) {
	    printf("\r  Writing %s (%d/%d chunks)", dicfile, n+1, chunks);
	    /*
	     * 1`Nǂݍ
	     */
	    where = curblk;
	    p = src;
	    len = 0;
	    if (prefetch) {
		/*
		 * src̖ɐǂ݂ubNȂ
		 * src̐擪ɃRs[
		 */
		memcpy(p, p + CHUNK_SIZE, BLOCK_SIZE);
		p += BLOCK_SIZE;
		len += BLOCK_SIZE;
		prefetch = FALSE;
	    }
	    while (curblk <= endblk && len < CHUNK_SIZE) {
		if (read_block(p, curbook, where) == NULL) {
		    msg = "\nread_block() failed. (7)";
		    goto err1;
		}
		curblk++;
		where = NEXT;
		p += BLOCK_SIZE;
		len += BLOCK_SIZE;
	    }
	    if (curblk <= endblk) {
		/*
		 * `N̖1ubNǂ݂
		 */
		if (read_block(p, curbook, where) == NULL) {
		    msg = "\nread_block() failed. (8)";
		    goto err1;
		}
		curblk++;
		prefetch = TRUE;
	    }
	    /*
	     * HONMONS/HONMONGւ̎QƂȂĔzu
	     */
	    if (id == ID_HONMON && (graphics != NULL || sound != NULL) ||
		id == ID_GRAPHMENU && graphics != NULL) {
		relocate_block(src, len, g_reloc, s_reloc, &g_count, &s_count);
		g_total += g_count;
		s_total += s_count;
	    }
	    /*
	     * `Nkďo
	     */
	    m = (len < LOOKUP_LEN)? len: LOOKUP_LEN;
	    fillch = find_fillch(src, m);
	    memset(buf, fillch, LOOKUP_LEN);
	    if (nohash)
		m = lz77_encode_dumb(dst, buf, len);
	    else
		m = lz77_encode_hash(dst, buf, len);
	    store_be(chdr.ndata, 4, m / 3);
	    chdr.fillch[0] = fillch;
	    if (write(fd, &chdr, sizeof(chdr)) != sizeof(chdr) ||
	        write(fd, dst, m) != m) {
		msg = "\nwrite() failed. (9)";
		goto err1;
	    }
	    store_be(ctbl[n].offset, 4, (dword)off);
	    off += sizeof(chdr) + m;
	}
	printf("\r");
	write_log("  Writing %s (%d/%d chunks)\n", dicfile, chunks, chunks);
	if (g_total > 0 && graphics != NULL) {
	    write_log("    %s references relocated (%d occurrences)\n",
		graphics->filename, g_total);
	}
	if (s_total > 0 && sound != NULL) {
	    write_log("    %s references relocated (%d occurrences)\n",
		sound->filename, s_total);
	}
	if (lseek(fd, sizeof(sdhdr), SEEK_SET) < 0) {
	    msg = "\nlseek() failed. (10)";
	    goto err;
	}
	m = sizeof(CHUNKTBL) * chunks;
	if (write(fd, ctbl, m) != m) {
	    msg = "\nwrite() failed. (11)";
	    goto err;
	}
	close(fd);
	free((char *)ctbl);
	continue;
    err1:
	printf("\r");
	write_log("  Writing %s (%d/%d chunks)", dicfile, n+1, chunks);
    err:
	write_log("%s\n", msg);
	close(fd);
	return -1;
    }
    return 0;
}

/*
 * HONMONG/HONMONSւ̎QƂĔzu
 */
void
relocate_block(byte *buf, int len, dword g_reloc, dword s_reloc, int *g_count, int *s_count)
{
    byte *p, *pend;
    dword topblk, endblk;

    p = buf;
    pend = &buf[len];
    *g_count = 0;
    *s_count = 0;
    while (p < pend) {
	if (*p != 0x1f) {
	    p += 2;
	    continue;
	}
	if (p[1] == 0x4d && g_reloc != (dword)0) {
	    /*
	     * HONMONGւ̎QƂ
	     */
	    topblk = load_bcd4(p + 14);
	    store_bcd4(p + 14, topblk + g_reloc);
	    (*g_count)++;
	    p += 20;
	}
	if (p[1] == 0x4a && s_reloc != (dword)0) {
	    /*
	     * HONMONSւ̎QƂ
	     */
	    topblk = load_bcd4(p + 6);
	    endblk = load_bcd4(p + 12);
	    store_bcd4(p + 6, topblk + s_reloc);
	    store_bcd4(p + 12, endblk + s_reloc);
	    (*s_count)++;
	    p += 18;
	}
	p += 2;
    }
}

/*
 * ڎt@C(*.idx)𐶐
 */
int
generate_idxfile(byte *infoblk, BOOK *book, byte *booktype, int opt, char *directory, char *title, char *ga16full, char *ga16half, dword dicid)
{
    int i, j, n, m, fd, items, multino;
    dword i16pos, i32pos, topblk, blks, endblk;
    char *msg, *fname, idxfile[32], idxpath[32], multifile[32];
    byte icon16[15 * 8], icon32[32 * 16];
    INFOHDR *infohdr;
    INFOITEM *infoitem;
    SIHDR sihdr;
    SIITEM siitem;

    /*
     * t@CJăwb_
     */
    sprintf(idxfile, "%s.IDX", directory);
    sprintf(idxpath, "Dic/%s/%s", directory, idxfile);
    if ((fd = open(idxpath, O_CREAT|O_WRONLY|O_TRUNC|O_BINARY, 0666)) < 0) {
	write_log("Can't create \"%s\"\n", idxpath);
	return -1;
    }
    write_log("  Writing %s\n", idxfile);
    n = 0;
    for (i = 0; i < NINFO; i++)
	n += fileinfo[i].used;
    if (*ga16full)
	n++;
    if (*ga16half)
	n++;
    i32pos = sizeof(sihdr) + (sizeof(siitem) * n);
    i16pos = i32pos + sizeof(icon32);
    memset(&sihdr, '\0', sizeof(sihdr));
    memcpy(sihdr.cookie, "SSEDINFO", 8);
    memcpy(sihdr.unknown1, "\x00\x02\x00\x02", 4);
    store_be(sihdr.titlelen, 1, (dword)strlen(title));
    strcpy(sihdr.title, title);
    store_be(sihdr.items, 1, (dword)n);
    memcpy(sihdr.booktype, booktype, 2);
    store_be(sihdr.i32pos, 4, i32pos);
    store_be(sihdr.i32len, 4, (dword)sizeof(icon32));
    store_be(sihdr.i16pos, 4, i16pos);
    store_be(sihdr.i16len, 4, (dword)sizeof(icon16));
    store_be(sihdr.dicid, 4, dicid);
    if (write(fd, &sihdr, sizeof(sihdr)) != sizeof(sihdr)) {
	msg = "write() failed. (12)";
	goto err;
    }
    /*
     * Ѝ\vf
     */
    infohdr = (INFOHDR *)infoblk;
    items = (int)load_be(infohdr->items, 2);
    infoitem = (INFOITEM *)&infohdr[1];
    multino = 1;
    for (i = 0; i < items; i++, infoitem++) {
	for (n = 0; n < NINFO; n++) {
	    if (fileinfo[n].id != infoitem->itemid[0])
		continue;
	    m = fileinfo[n].opt;
	    if (m == C_XXX ||
		m == C_OPT && !(opt & DO_OPTIONAL) ||
		m == C_GRA && !(opt & DO_GRAPHICS) ||
		m == C_SND && !(opt & DO_SOUND))
		continue;
	    goto found;
	}
	continue;
    found:
	topblk = load_be(infoitem->topblk, 4);
	if (fileinfo[n].id == ID_MULTI) {
	    blks = multi_blocks(book, &topblk);
	    sprintf(multifile, "MULTI%d.DIC", multino++);
	    fname = multifile;
	} else {
	    blks = load_be(infoitem->blks, 4);
	    fname = fileinfo[n].name;
	}
	endblk = topblk + blks - 1;
	memset(&siitem, '\0', sizeof(siitem));
	memcpy(siitem.id, infoitem->itemid, 1);
	store_be(siitem.topblk, 4, topblk);
	store_be(siitem.endblk, 4, endblk);
	memcpy(siitem.idxvalid, infoitem->idxvalid, 1);
	memcpy(siitem.idxinfo, infoitem->idxinfo, 3);
	store_be(siitem.fnamelen, 1, strlen(fname));
	strcpy(siitem.fname, fname);
	if (write(fd, &siitem, sizeof(siitem)) != sizeof(siitem)) {
	    msg = "write() failed. (13)";
	    goto err;
	}
    }
    if (*ga16full) {
	memset(&siitem, '\0', sizeof(siitem));
	siitem.id[0] = 0xf1;
	store_be(siitem.fnamelen, 1, strlen(ga16full));
	strcpy(siitem.fname, ga16full);
	if (write(fd, &siitem, sizeof(siitem)) != sizeof(siitem)) {
	    msg = "write() failed. (14)";
	    goto err;
	}
    }
    if (*ga16half) {
	memset(&siitem, '\0', sizeof(siitem));
	siitem.id[0] = 0xf2;
	store_be(siitem.fnamelen, 1, strlen(ga16half));
	strcpy(siitem.fname, ga16half);
	if (write(fd, &siitem, sizeof(siitem)) != sizeof(siitem)) {
	    msg = "write() failed. (15)";
	    goto err;
	}
    }
    /*
     * ACR
     */
    set_icon_data(directory, icon16, icon32);
    if (write(fd, icon32, sizeof(icon32)) != sizeof(icon32)) {
	msg = "write() failed. (16)";
	goto err;
    }
    if (write(fd, icon16, sizeof(icon16)) != sizeof(icon16)) {
	msg = "write() failed. (17)";
	goto err;
    }
    close(fd);
    return 0;
err:
    write_log("%s\n", msg);
    close(fd);
    return -1;
}

/*
 * DICPROF.INIt@C𐶐
 */
int
generate_dicprof(char *directory, char *title, char *ga16full, char *ga16half, dword dicid)
{
    int i, j, n, m, nreq, nopt, ngra, nsnd, ocomp;
    char dicprof[32];
    FILE *fp;

    write_log("  Writing DICPROF.INI\n");
    nreq = 3;	/* DICPROF.INI, EXINFO.INI, (directory).IDX */
    nopt = 0;
    ngra = 0;
    nsnd = 0;
    for (i = 0; i < NINFO; i++) {
	if (fileinfo[i].used) {	/* process_items()ŃZbg */
	    n = fileinfo[i].opt;
	    if (n == C_OPT)
		nopt += fileinfo[i].used;
	    else if (n == C_GRA)
		ngra++;
	    else if (n == C_SND)
		nsnd++;
	    else
		nreq++;
	}
    }
    if (*ga16full)
	nreq++;
    if (*ga16half)
	nreq++;
    ocomp = 0;
    if (nopt > 0)
	ocomp++;
    if (ngra > 0)
	ocomp++;
    if (nsnd > 0)
	ocomp++;
    sprintf(dicprof, "Dic/%s/DICPROF.INI", directory);
    if ((fp = fopen(dicprof, "w")) == NULL)
	return -1;
    fprintf(fp, "[GENERAL]\n");
    fprintf(fp, "DicName=%s\n", title);
    fprintf(fp, "DicId=%ld\n", dicid);
    fprintf(fp, "DicDir=%s\n", directory);
    fprintf(fp, "RequiredFiles=%d\n", nreq);
    fprintf(fp, "OptionalComponents=%d\n", ocomp);
    fprintf(fp, "DESC=̃R|[lǵu%sv̎Tf[^܂ł܂B\n", title);
    fprintf(fp, "[REQUIRED]\n");
    fprintf(fp, "NAME=Tf[^\n");
    fprintf(fp, "DESC=̃R|[lg͌CfbNXA{f[^܂ł܂B\n");
    fprintf(fp, "FILE1=DICPROF.INI\n");
    fprintf(fp, "FILE2=EXINFO.INI\n");
    fprintf(fp, "FILE3=%s.IDX\n", directory);
    n = 4;
    for (i = 0; i < NINFO; i++) {
	if (fileinfo[i].used && fileinfo[i].opt == C_REQ)
	    fprintf(fp, "FILE%d=%s\n", n++, fileinfo[i].name);
    }
    if (*ga16full)
	fprintf(fp, "FILE%d=%s\n", n++, ga16full);
    if (*ga16half)
	fprintf(fp, "FILE%d=%s\n", n++, ga16half);
    if (ocomp > 0) {
	m = 1;
	if (nopt > 0) {
	    fprintf(fp, "[OPTIONAL%d]\n", m++);
	    fprintf(fp, "NAME=IvVCfbNX\n");
	    fprintf(fp, "DESC=̃R|[lg̓IvVCfbNX܂ł܂B\n");
	    fprintf(fp, "FILES=%d\n", nopt);
	    n = 1;
	    for (i = 0; i < NINFO; i++) {
		if (!fileinfo[i].used || fileinfo[i].opt != C_OPT)
		    continue;
		if (fileinfo[i].id == ID_MULTI) {
		    for (j = 1; j <= fileinfo[i].used; j++)
			fprintf(fp, "FILE%d=MULTI%d.DIC\n", n++, j);
		} else {
		    fprintf(fp, "FILE%d=%s\n", n++, fileinfo[i].name);
		}
	    }
	}
	if (ngra > 0) {
	    fprintf(fp, "[OPTIONAL%d]\n", m++);
	    fprintf(fp, "NAME=J[}Ńf[^\n");
	    fprintf(fp, "DESC=̃R|[lg̓J[}Ńf[^܂ł܂B\n");
	    fprintf(fp, "FILES=%d\n", ngra);
	    n = 1;
	    for (i = 0; i < NINFO; i++) {
		if (fileinfo[i].used && fileinfo[i].opt == C_GRA)
		    fprintf(fp, "FILE%d=%s\n", n++, fileinfo[i].name);
	    }
	}
	if (nsnd > 0) {
	    fprintf(fp, "[OPTIONAL%d]\n", m++);
	    fprintf(fp, "NAME=f[^\n");
	    fprintf(fp, "DESC=̃R|[lg͉f[^܂ł܂B\n");
	    fprintf(fp, "FILES=%d\n", nsnd);
	    n = 1;
	    for (i = 0; i < NINFO; i++) {
		if (fileinfo[i].used && fileinfo[i].opt == C_SND)
		    fprintf(fp, "FILE%d=%s\n", n++, fileinfo[i].name);
	    }
	}
    }
    fclose(fp);
    return 0;
}

/*
 * EXINFO.INIt@C𐶐
 */
int
generate_exinfo(char *directory, char *title)
{
    char exinfo[32];
    FILE *fp;

    write_log("  Writing EXINFO.INI\n");
    sprintf(exinfo, "Dic/%s/EXINFO.INI", directory);
    if ((fp = fopen(exinfo, "w")) == NULL)
	return -1;
    fprintf(fp, "[GENERAL]\n");
    fprintf(fp, "SRCINFO=%s\n", title);
    fclose(fp);
    return 0;
}

/*
 * WXgo^t@C(*.reg)𐶐
 */
int
generate_regfile(char *directory, char *title, dword dicid)
{
    char regfile[32], regpath[32];
    FILE *fp;

    sprintf(regfile, "%s.REG", directory);
    write_log("  Writing %s\n", regfile);
    sprintf(regpath, "Dic/%s", regfile);
    if ((fp = fopen(regpath, "w")) == NULL)
	return -1;
    fprintf(fp, "REGEDIT4\n\n");
    fprintf(fp, "[HKEY_LOCAL_MACHINE\\Software\\SystemSoft\\SSDictionary\\Dic\\%08X]\n", dicid);
    fprintf(fp, "\"DicID\"=dword:%08X\n", dicid);
    fprintf(fp, "\"DicName\"=\"%s\"\n", title);
    fprintf(fp, "\"DicPath\"=\"C:\\\\Program Files\\\\SystemSoft\\\\EDViewer\\\\DIC\\\\%s\\\\%s.IDX\"\n", directory, directory);
    fprintf(fp, "\"SRCINFO\"=\"%s\"\n", title);
    fclose(fp);
    return 0;
}

/*
 * Ot@CRs[
 */
int
copy_gaiji(char *frompath, char *todir, char *tofile)
{
    int n, fd1, fd2;
    char topath[32];
    char buf[BUFSIZ];

    write_log("  Writing %s\n", tofile);
    sprintf(topath, "Dic/%s/%s", todir, tofile);
    if ((fd1 = open(frompath, O_RDONLY|O_BINARY)) < 0)
	return -1;
    if ((fd2 = open(topath, O_CREAT|O_WRONLY|O_TRUNC|O_BINARY, 0666)) < 0) {
	close(fd1);
	return -1;
    }
    while ((n = read(fd1, buf, BUFSIZ)) > 0) {
	if (write(fd2, buf, n) != n) {
	    close(fd1);
	    close(fd2);
	    return -1;
	}
    }
    close(fd1);
    close(fd2);
    return 0;
}

/*
 * SSEDID(ǂ)𐶐
 */
dword
make_dicid(char *directory)
{
    dword dicid;
    char buf[9];

    memset(buf, '\0', 9);
    strcpy(buf, directory);
    /*
     * fBNg̑O4̉4rbgA
     * 㔼4̉3rbg玫ID
     */
    dicid = ((buf[0] & 0x0f) << 24) |
	    ((buf[1] & 0x0f) << 20) |
	    ((buf[2] & 0x0f) << 16) |
	    ((buf[3] & 0x0f) << 12) |
	    ((buf[4] & 0x07) <<  9) |
	    ((buf[5] & 0x07) <<  6) |
	    ((buf[6] & 0x07) <<  3) |
	    ((buf[7] & 0x07)      );
    return dicid;
}

/*
 * ACR`f[^Zbg
 */
int
set_icon_data(char *directory, byte *icon16, byte *icon32)
{
    int i;
    char *name16, *name32, key[32];
    FILE *fp;

    name16 = name32 = NULL;
    if ((fp = fopen(ICON_DEF_FILE, "r")) != NULL) {
	sprintf(key, "[%s_16]", directory);
	if (find_key(fp, key)) {
	    read_icon(fp, icon16, 15, 16);
	    name16 = directory;
	} else if (find_key(fp, "[DEFAULT_16]")) {
	    read_icon(fp, icon16, 15, 16);
	    name16 = "DEFAULT";
	}
	sprintf(key, "[%s_32]", directory);
	if (find_key(fp, key)) {
	    read_icon(fp, icon32, 32, 32);
	    name32 = directory;
	} else if (find_key(fp, "[DEFAULT_32]")) {
	    read_icon(fp, icon32, 32, 32);
	    name32 = "DEFAULT";
	}
	fclose(fp);
    }
    if (!name16) {
	for (i = 0; i < 15; i++)
	    memcpy(&icon16[(14-i)*8], def_icon16[i], 8);
	name16 = "INTERNAL";
    }
    if (!name32) {
	for (i = 0; i < 32; i++)
	    memcpy(&icon32[(31-i)*16], def_icon32[i], 16);
	name32 = "INTERNAL";
    }
    write_log("    Selected icons: %s_16, %s_32\n", name16, name32);
    return 0;
}

/*
 * ACR`t@CL[sT
 */
int
find_key(FILE *fp, char *key)
{
    int keylen;
    char buf[128];

    keylen = strlen(key);
    rewind(fp);
    while (fgets(buf, 128, fp) != NULL) {
	if (!strncmp(buf, key, keylen))
	    return TRUE;
    }
    return FALSE;
}

/*
 * ACR`t@Cǂݍ
 */
int
read_icon(FILE *fp, byte *icon, int row, int col)
{
    int i, j, c1, c2;
    char *p, buf[128];
    byte val;

    i = 0;
    while (i < row) {
	if (fgets(buf, 128, fp) == NULL || *buf == '[')
	    break;
	if (*buf == ';' || *buf == '\n' || *buf == '\r')
	    continue;
	p = buf;
	for (j = 0; j < col; j++) {
	    if (*p == '\n' || *p == '\r' || *p == '\0')
		break;
	    p++;
	}
	for (; j < col; j++)
	    *p++ = '0';
	p = buf;
	for (j = 0; j < col/2; j++) {
	    c1 = *p++;
	    c2 = *p++;
	    if (c1 >= '0' && c1 <= '9')
		val = (c1 - '0') << 4;
	    else if (c1 >= 'A' && c1 <= 'F')
		val = (c1 - 'A' + 10) << 4;
	    else if (c1 >= 'a' && c1 <= 'f')
		val = (c1 - 'a' + 10) << 4;
	    else
		val = 0;
	    if (c2 >= '0' && c2 <= '9')
		val |= (c2 - '0');
	    else if (c2 >= 'A' && c2 <= 'F')
		val |= (c2 - 'A' + 10);
	    else if (c2 >= 'a' && c2 <= 'f')
		val |= (c2 - 'a' + 10);
	    else
		val |= 0;
	    icon[(row-i-1) * (col/2) + j] = val;
	}
	i++;
    }
    while (i < row) {
	memset(&icon[row-i-1], '\0', col/2);
	i++;
    }
    return 0;
}

/*
 * XCh̏߂
 */
int
find_fillch(byte *buf, int len)
{
    int i, n, f, freq[256];

    /*
     * buf̊ȅopxfreqɋ߂
     */
    for (i = 0; i < 256; i++)
	freq[i] = 0;
    for (i = 0; i < len; i++)
	freq[*buf++]++;
    /*
     * opxő̕nTĕԂ
     */
    n = 0;
    f = -1;
    for (i = 0; i < 256; i++) {
	if (freq[i] > f) {
	    f = freq[i];
	    n = i;
	}
    }
    return n;
}

/*
 * LZ77ŕ(P)
 */
int
lz77_encode_dumb(byte *dstbuf, byte *srcbuf, int srclen)
{
    int clen, mlen, pos;
    byte *p, *lookup, *coding, *srcend, *dst;

    lookup = srcbuf;
    coding = srcbuf + LOOKUP_LEN;
    srcend = srcbuf + LOOKUP_LEN + srclen;
    dst = dstbuf;
    /*
     * XCh炵ȂLZ77s
     */
    while (coding < srcend - 1) {
	/*
	 * ő}b`CODING_LENA
	 * \[X̕ɂƂ
	 * ̒O܂ł}b`Ƃ
	 */
	if (coding + CODING_LEN < srcend)
	    clen = CODING_LEN;
	else
	    clen = srcend - coding - 1;
	/*
	 * XCh(lookupcoding̒O܂)
	 * codingclenoCgɃ}b`Œ̕T
	 * (hashtree/triegčׂ...)
	 */
	p = longest_match(lookup, LOOKUP_LEN, coding, clen, &mlen);
	if (p == NULL) {
	    /*
	     * }b`Ȃ
	     * (0,0,ch)o͂ăXCh1炷
	     */
	    *dst++ = 0x00;
	    *dst++ = 0x00;
	    *dst++ = *coding++;
	    lookup++;
	} else {
	    /*
	     * pmlenɃ}b`
	     * (lookup̑Έʒu,}b`,㑱)
	     * o͂ăXChmlen+1炷
	     */
	    pos = p - lookup;
	    *dst++ = pos >> 4;
	    *dst++ = ((pos & 0x0f) << 4) | mlen;
	    *dst++ = *(coding + mlen);
	    lookup += mlen + 1;
	    coding += mlen + 1;
	}
    }
    /*
     * \[X1܂o͂ĂȂ
     * (0,0,ch)Ƃďo͂
     */
    if (coding < srcend) {
	*dst++ = 0x00;
	*dst++ = 0x00;
	*dst++ = *coding;
    }
    return dst - dstbuf;
}

/*
 * eLXgp^[Ƀ}b`Œ̕T
 */
byte *
longest_match(byte *text, int tlen, byte *pat, int plen, int *mlenp)
{
    byte *t, *p, *tt, *pp, *tend;
    int i, mlen;
    int skip[256];

    /*
     * eLXgp^[̐擪T
     */
    tend = text + tlen;
    p = pat;
    for (t = text; t < tend; t++) {
	if (*t == *p)
	    break;
    }
    if (t >= tend) {
	/*
	 * eLXgɃp^[̐擪Ȃ
	 */
	*mlenp = 0;
	return NULL;
    }
    /*
     * }b`2plen܂ő₵ȂA
     * Õ}b`ʒuȍ~Ń}b`ʒuT
     */
    for (mlen = 2; mlen <= plen; mlen++) {
	/*
	 * BMH@̃XLbvʂvZ
	 */
	for (i = 0; i < 256; i++)
	    skip[i] = mlen;
	for (i = 0; i < mlen - 1; i++)
	    skip[pat[i]] = mlen - i - 1;
	/*
	 * T͈͂͒Otp^[̐擪
	 * eLXg̍ŏIƏdȂʒu܂
	 */
	text = t;
	/*
	 * BMH@ŃeLXgp^[T
	 */
	t = text;
	p = pat;
	while (t < tend) {
	    tt = t + mlen - 1;
	    pp = p + mlen - 1;
	    while (*tt == *pp) {
		if (pp == p)
		    goto found;
		tt--;
		pp--;
	    }
	    t += skip[*tt];
	}
	/*
	 * Ȃ̂
	 * Õ}b`ʒuƃ}b`Ԃ
	 */
	*mlenp = mlen - 1;
	return text;
    found:
	/*
	 * ̂
	 * }b`1₵ĒT𑱍s
	 */
	;
    }
    /*
     * ő咷Ń}b`
     * Ō̃}b`ʒuƃp^[Ŝ̒Ԃ
     */
    *mlenp = plen;
    return t;
}

/*
 * LZ77ŕ(nbVgp)
 */
int
lz77_encode_hash(byte *dstbuf, byte *srcbuf, int srclen)
{
    int clen, mlen, pos;
    byte *coding, *srcend, *dst;

    coding = srcbuf + LOOKUP_LEN;
    srcend = srcbuf + LOOKUP_LEN + srclen;
    dst = dstbuf;
    hash_init(srcbuf);
    /*
     * XCh炵ȂLZ77s
     */
    while (coding < srcend - 1) {
	/*
	 * ő}b`CODING_LENA
	 * \[X̕ɂƂ
	 * ̒O܂ł}b`Ƃ
	 */
	if (coding + CODING_LEN < srcend)
	    clen = CODING_LEN;
	else
	    clen = srcend - coding - 1;
	/*
	 * codingclenoCgɃ}b`Œ̕T
	 */
	pos = find_match(srcbuf, coding, clen, &mlen);
	if (pos < 0) {
	    /*
	     * }b`Ȃ
	     * (0,0,ch)o͂ăXCh1炷
	     */
	    hash_update(srcbuf, srcend, coding, 1);
	    *dst++ = 0x00;
	    *dst++ = 0x00;
	    *dst++ = *coding++;
	} else {
	    /*
	     * pmlenɃ}b`
	     * (lookup̑Έʒu,}b`,㑱)
	     * o͂ăXChmlen+1炷
	     */
	    hash_update(srcbuf, srcend, coding, mlen + 1);
	    *dst++ = pos >> 4;
	    *dst++ = ((pos & 0x0f) << 4) | mlen;
	    *dst++ = *(coding + mlen);
	    coding += mlen + 1;
	}
    }
    /*
     * \[X1܂o͂ĂȂ
     * (0,0,ch)Ƃďo͂
     */
    if (coding < srcend) {
	*dst++ = 0x00;
	*dst++ = 0x00;
	*dst++ = *coding;
    }
    return dst - dstbuf;
}

/*
 * nbV\
 */
void
hash_init(byte *srctop)
{
    byte *p, *coding;

    /*
     * e[ȗSvfH_EMPTYŖ߂
     */
    memset((char *)htbl, 0xff, sizeof(htbl));
    memset((char *)href, 0xff, sizeof(href));
    memset((char *)b2tbl, 0xff, sizeof(b2tbl));
    memset((char *)b1tbl, 0xff, sizeof(b1tbl));
    /*
     * ee[u
     * (srctop̍ŏLOOKUP_LENoCg
     * Ŗ߂Ă̂
     * ʒuȌoL^΂悢)
     */
    coding = srctop + LOOKUP_LEN;
    for (p = coding - CODING_LEN; p < coding; p++)
	hash_insert(srctop, p, CODING_LEN);
    b2tbl[(coding[-2] << 8) | coding[-1]] = LOOKUP_LEN - 2;
    b2tbl[(coding[-1] << 8) | coding[0]] = LOOKUP_LEN - 1;
    b1tbl[coding[-1]] = LOOKUP_LEN - 1;
}

/*
 * nbV֐
 */
int
hash(byte *s)
{
    return ((((((int)s[0] << 7) + (int)s[1]) << 7) + (int)s[2]) << 7) % HASH_SIZE;
}

/*
 * 3oCgnbV\ɗvf}
 */
void
hash_insert(byte *srctop, byte *str, int restlen)
{
    int n, key, pos, syn;
    HASHTBL *h, *hend;
    
    key = hash(str);
    h = &htbl[key];
    hend = &htbl[HASH_SIZE];
    if (restlen >= CODING_LEN) {
	syn = 0;
	while (h->pos < H_DELETED) {
	    if (h->key == key &&
	        matchlen(srctop + h->pos, str, CODING_LEN) == CODING_LEN)
		break;
	    if (++syn >= SYNONYM_MAX) {
		/*
		 * Vmjő吔𒴂̂
		 * nbV\ɓo^ȂŖ߂
		 */
		return;
	    }
	    if (++h >= hend)
		h = htbl;
	}
    } else {
	while (h->pos < H_DELETED) {
	    if (++h >= hend)
		h = htbl;
	}
    }
    pos = str - srctop;
    h->key = key;
    h->pos = pos;
    href[pos] = h - htbl;
}

/*
 * nbV\XV
 */
void
hash_update(byte *srctop, byte *srcend, byte *coding, int shift)
{
    int i, out;
    byte *p;

    p = coding;
    for (i = 0; i < shift; i++) {
	out = p - LOOKUP_LEN - srctop;
	if (href[out] != H_EMPTY) {
	    htbl[href[out]].pos = H_DELETED;
	    href[out] = H_EMPTY;
	}
	if (p < srcend - 2)
	    hash_insert(srctop, p, srcend - p);
	if (p < srcend - 1)
	    b2tbl[(p[0] << 8) | p[1]] = p - srctop;
	if (p < srcend)
	    b1tbl[p[0]] = p - srctop;
	p++;
    }
}

/*
 * }b`ʒuT
 */
int
find_match(byte *srctop, byte *coding, int maxlen, int *mlen)
{
    int key, len, slen, spos, lupos;
    HASHTBL *h, *hend;

    lupos = coding - srctop - LOOKUP_LEN;
    if (maxlen >= 3) {
	key = hash(coding);
	h = &htbl[key];
	hend = &htbl[HASH_SIZE];
	slen = 0;
	while (h->pos != H_EMPTY) {
	    if (h->key == key && h->pos != H_DELETED) {
		len = matchlen(srctop + h->pos, coding, maxlen);
		if (len == maxlen) {
		    *mlen = maxlen;
		    return h->pos - lupos;
		}
		if (len > slen) {
		    slen = len;
		    spos = h->pos;
		}
	    }
	    if (++h >= hend)
		h = htbl;
	}
	if (slen >= 3) {
	    *mlen = slen;
	    return spos - lupos;
	}
    }
    if (maxlen >= 2) {
	spos = b2tbl[(coding[0] << 8) | coding[1]];
	if (spos < H_EMPTY && spos >= lupos) {
	    *mlen = 2;
	    return spos - lupos;
	}
    }
    spos = b1tbl[coding[0]];
    if (spos < H_EMPTY && spos >= lupos) {
	*mlen = 1;
	return spos - lupos;
    }
    return -1;
}

/*
 * oCg̈v钷Ԃ
 */
int
matchlen(byte *s1, byte *s2, int len)
{
    int n;

    for (n = 0; n < len; n++)
	if (*s1++ != *s2++)
	    break;
    return n;
}
